#include <stdio.h>
#include <string.h>
#include <Rabbit2000.h>
#include "net2000.h"

far void main(void)
{
    // Dummy configuration, will be overwritten by DHCP
    NetConfig config;
    NetConnectionConfig interface;
    int ethStatus;
    char MACString[20];
    int productID;

    WDT_DISABLE();

    // Clear the Softools WinIDE print buffer from any previous program runs
    printf("\x1A");
    productID = netRecognize();
    strcpy(config.hostName, "test");
    strcpy(config.domainName, "toman.ws");
    config.defaultIpGateway = inet_addr("192.168.1.1");
    netConfigure(&config);

    // Start ethernet with DHCP using default handlers (will respond to
    // ICMP echo requests)
    printf("** Starting Ethernet Interface **\n");
    printf("Rabbit 2000 board or core module %s recognized\n",
           (productID ? "is" : "is not"));

    interface.connType = ETH_CONN;
    interface.ipAddress = inet_addr("192.168.1.40");
    // Netmasks of the form 192.168.1.255 will fail!
    interface.netmask = inet_addr("255.255.255.0");


    // Start timer up. This *must* be done or the TCP/IP stack may not
    // behave correctly.
    // Interrupt handler to process incoming packets runs at regular
    // intervals (in this case 100 times per second).
    // Note that the ethernet doesn't have to be started to run this timer.
    startTimer(100, netProcess, 2);
    ipset1();

    // Start ethernet interface
    ethStatus = ethernetStart(NULL, NULL);
    //ethStatus = ethernetStart(&interface, "192.168.1.2", NULL);
    //ethStatus = ethernetStart(&interface, "192.168.1.1", NULL);
    //ethStatus = ethernetStart(&interface, NULL);
    printf("MAC: %s\n", netGetMAC(MACString));
    if (ethStatus == 3)
    {
        // DHCP failed, use fallback address
        printf("DHCP/BOOTP failed; no ip address\n");
        printf("failsafe address is 192.168.1.40, no DNS\n");
        ethStatus = ethernetStart(&interface, NULL);
    }

    if (ethStatus != 0)
    {
        // Error code: ethernet initialization failed somehow
        printf("Got error code %d", ethStatus);
    }
    else
    {
        // Successful initialization
        char name[HOSTNAME_LENGTH];
        longword address;
        eth_address addr;

        printf("Ethernet initialization succeeded\n");
        gethostname(name, HOSTNAME_LENGTH);
        printf("hostname: %s\n", name);
        getdomainname(name, HOSTNAME_LENGTH);
        printf("domain: %s\n", name);
        printf("ip: %s\n", inet_ntoa(name, interfaces[0].ipAddress));

        // Get some ARP lookups going
        //_arp_resolve(inet_addr("192.168.1.1"), &addr, 0);
        //printf("192.168.1.1 -> %s\n", etherAddressToString(name, &addr));
        //_arp_resolve(inet_addr("192.168.1.2"), &addr, 0);
        //printf("192.168.1.2 -> %s\n", etherAddressToString(name, &addr));
        //_arp_resolve(inet_addr("192.168.1.8"), &addr, 0);
        //printf("192.168.1.8 -> %s\n", etherAddressToString(name, &addr));

        // Do a test DNS lookup

        address = resolve("www.compendium-tech.com");
        printf("DNS: www.compendium-tech.com resolves to %s\n",
               inet_ntoa(name, address));
        address = resolve("www.softools.com");
        printf("DNS: www.softools.com resolves to %s\n",
               inet_ntoa(name, address));
        address = resolve("www.espn.com");
        printf("DNS: www.espn.com resolves to %s\n",
               inet_ntoa(name, address));
        address = resolve("www.cnn.com");
        printf("DNS: www.cnn.com resolves to %s\n",
               inet_ntoa(name, address));
        address = resolve("www.toman.ws");
        printf("DNS: www.toman.ws resolves to %s\n",
               inet_ntoa(name, address));
        address = resolve("www.padres.com");
        printf("DNS: www.padres.com resolves to %s\n",
               inet_ntoa(name, address));
        address = resolve("www.kernel.org");
        printf("DNS: www.kernel.org resolves to %s\n",
               inet_ntoa(name, address));

        printf("looping\n");
        while(1); // Loop forever. Rabbit device should be pingable.
    }

}
