/*
 * Contains the packet driver variables for the RTK8019as 10megabit ethernet
 * controller chip.
 *
 * (C) 2002 Softools, Inc.
 * (C) 2002 Compendium Technologies, Inc.
 * All rights reserved.
 */

#include "Rabbit2000.h"
#include "RTK8019AS.h"

/*
 * These variables are used to configure the RTK8019AS driver. They do not
 * represent everything that can be configured. The defaults here will
 * work with the Rabbit Semiconductor TCP/IP Dev Kit only. Core modules
 * require configuration of these variables, which can be accomplished with
 * netRecognize().
 */

unsigned int  rtkWriteAddress = 0xC000; // DMA address line to write data to the
                                        // RTK8019as
unsigned int  rtkReadAddress  = 0xE000; // DMA address line to read data from
                                        // the RTK8019as for RCM2XXX modules
unsigned char rtkBoardType = RTK_BOARD_TYPE_DEVKIT;

/*
 * The following variables are for emulating the EEPROM with the Rabbit 2000,
 * which the Rabbit Semiconductor RCM2XXX core modules do. These variables are
 * not used by the Dev Kit, which has a 9346 EEPROM part on the board. The
 * default settings here are good for use with the RCM2100 core module.
 */
unsigned char rtkLEDs   = 0x30;  // Turns on LED lights in emulation (half
                                 // duplex)
unsigned int  rtkEEPORT = PDDR;  // What port to use for 9346 emulation clock
unsigned int  rtkEEDO   = PDB7R; // What port to use to write EEPROM emulation
unsigned char rtkEEDI   = 0x40;
unsigned char rtkEESK   = 0x20;
/*
 * MAC address for RCM2XXX core modules, set by netRecognize().
 */
struct eth_addr rtkEthernetAddress;
